Index: contrib/amd/include/am_defs.h
===================================================================
RCS file: /home/ncvs/src/contrib/amd/include/am_defs.h,v
retrieving revision 1.8
diff -u -r1.8 am_defs.h
--- contrib/amd/include/am_defs.h	1999/11/05 11:58:03	1.8
+++ contrib/amd/include/am_defs.h	2000/04/12 17:04:20
@@ -445,6 +445,7 @@
  * Actions to take if <sys/ucred.h> exists.
  */
 #ifdef HAVE_SYS_UCRED_H
+#include <sys/capability.h>
 # include <sys/ucred.h>
 #endif /* HAVE_SYS_UCRED_H */
 
Index: etc/rc
===================================================================
RCS file: /home/ncvs/src/etc/rc,v
retrieving revision 1.244
diff -u -r1.244 rc
--- etc/rc	2000/12/17 08:24:49	1.244
+++ etc/rc	2001/01/05 16:50:06
@@ -204,6 +204,19 @@
 		sh ${diskless_mount}
 fi
 
+case ${extattr_root} in
+[Nn][Oo] | '')
+	;;
+*)
+	echo Starting extended attributes on root file system.
+	/usr/sbin/extattrctl start /
+	cd /.attribute && for file in *
+	do
+		/usr/sbin/extattrctl enable / $file /.attribute/$file
+	done
+	;;
+esac
+
 # Second attempt at reseeding, if needed.
 #
 case ${entropy_reseeded} in
Index: etc/defaults/rc.conf
===================================================================
RCS file: /home/ncvs/src/etc/defaults/rc.conf,v
retrieving revision 1.83
diff -u -r1.83 rc.conf
--- etc/defaults/rc.conf	2000/10/29 19:59:04	1.83
+++ etc/defaults/rc.conf	2000/11/07 02:25:17
@@ -322,6 +322,7 @@
 update_motd="YES"	# update version info in /etc/motd (or NO)
 start_vinum=""		# set to YES to start vinum
 unaligned_print="YES"	# print unaligned access warnings on the alpha (or NO).
+extattr_root="NO"	# Auto-start extended attributes on / at boot
 entropy_file="/entropy" # Set to NO to disable caching entropy through reboots.
 			# /var/db/entropy is preferred if / is not available.
 
Index: lib/libc/gen/getmntinfo.c
===================================================================
RCS file: /home/ncvs/src/lib/libc/gen/getmntinfo.c,v
retrieving revision 1.1.1.1
diff -u -r1.1.1.1 getmntinfo.c
--- lib/libc/gen/getmntinfo.c	1994/05/27 04:56:40	1.1.1.1
+++ lib/libc/gen/getmntinfo.c	2000/01/09 07:19:44
@@ -36,6 +36,7 @@
 #endif /* LIBC_SCCS and not lint */
 
 #include <sys/param.h>
+#include <sys/capability.h>
 #include <sys/ucred.h>
 #include <sys/mount.h>
 #include <stdlib.h>
Index: lib/libposix1e/Makefile
===================================================================
RCS file: /home/ncvs/src/lib/libposix1e/Makefile,v
retrieving revision 1.9
diff -u -r1.9 Makefile
--- lib/libposix1e/Makefile	2000/10/13 18:24:58	1.9
+++ lib/libposix1e/Makefile	2000/10/23 06:45:16
@@ -1,5 +1,6 @@
 # $FreeBSD: src/lib/libposix1e/Makefile,v 1.9 2000/10/13 18:24:58 rwatson Exp $
 
+CFLAGS+=-g -Wall
 MAINTAINER=	rwatson@FreeBSD.org
 LIB=	posix1e
 SHLIB_MAJOR= 2 
Index: sys/coda/coda_namecache.c
===================================================================
RCS file: /home/ncvs/src/sys/coda/coda_namecache.c,v
retrieving revision 1.10
diff -u -r1.10 coda_namecache.c
--- sys/coda/coda_namecache.c	1999/08/28 00:40:53	1.10
+++ sys/coda/coda_namecache.c	2000/04/12 04:43:28
@@ -79,6 +79,7 @@
 #include <sys/param.h>
 #include <sys/errno.h>
 #include <sys/malloc.h>
+#include <sys/capability.h>
 #include <sys/ucred.h>
 #include <sys/select.h>
 
Index: sys/fs/hpfs/hpfs_vnops.c
===================================================================
RCS file: /home/ncvs/src/sys/fs/hpfs/hpfs_vnops.c,v
retrieving revision 1.8
diff -u -r1.8 hpfs_vnops.c
--- sys/fs/hpfs/hpfs_vnops.c	2000/11/01 17:57:22	1.8
+++ sys/fs/hpfs/hpfs_vnops.c	2000/11/07 02:41:02
@@ -579,7 +579,7 @@
 		if (vp->v_mount->mnt_flag & MNT_RDONLY)
 			return (EROFS);
 		if (cred->cr_uid != hp->h_uid &&
-		    (error = suser_xxx(cred, p, PRISON_ROOT)) &&
+		    (error = cap_check(cred, p, CAP_FOWNER, PRISON_ROOT)) &&
 		    ((vap->va_vaflags & VA_UTIMES_NULL) == 0 ||
 		    (error = VOP_ACCESS(vp, VWRITE, cred, p))))
 			return (error);
Index: sys/isa/fd.c
===================================================================
RCS file: /home/ncvs/src/sys/isa/fd.c,v
retrieving revision 1.192
diff -u -r1.192 fd.c
--- sys/isa/fd.c	2000/12/08 21:50:26	1.192
+++ sys/isa/fd.c	2000/12/13 05:37:16
@@ -2411,8 +2411,9 @@
 
 	case FD_STYPE:                  /* set drive type */
 		/* this is considered harmful; only allow for superuser */
-		if (suser(p) != 0)
-			return EPERM;
+		if ((error = cap_check(NULL, p, CAP_SYS_ADMIN, 0)) != 0)
+			return (error);
+		suser_used(p);
 		*fd->ft = *(struct fd_type *)addr;
 		break;
 
Index: sys/isofs/cd9660/cd9660_vfsops.c
===================================================================
RCS file: /home/ncvs/src/sys/isofs/cd9660/cd9660_vfsops.c,v
retrieving revision 1.81
diff -u -r1.81 cd9660_vfsops.c
--- sys/isofs/cd9660/cd9660_vfsops.c	2000/12/08 21:50:31	1.81
+++ sys/isofs/cd9660/cd9660_vfsops.c	2000/12/13 05:37:18
@@ -223,13 +223,21 @@
 
 	/*       
 	 * Verify that user has necessary permissions on the device,
-	 * or has superuser abilities
+	 * or has superuser abilities.
+	 *
+	 * XXX: Capability check is to see if caller can override
+	 * permissions protecting the device.  Perhaps also should
+	 * be checks for the right to open devices?  Also, what about
+	 * securelevel?
 	 */
 	accessmode = VREAD;
 	vn_lock(devvp, LK_EXCLUSIVE | LK_RETRY, p);
 	error = VOP_ACCESS(devvp, accessmode, p->p_ucred, p);
-	if (error) 
-		error = suser(p);
+	if (error) {
+		error = cap_check(NULL, p, CAP_DAC_READ_SEARCH, 0);
+		if (error == 0)
+			suser_used(p);
+	}
 	if (error) {
 		vput(devvp);
 		return (error);
Index: sys/kern/init_main.c
===================================================================
RCS file: /home/ncvs/src/sys/kern/init_main.c,v
retrieving revision 1.151
diff -u -r1.151 init_main.c
--- sys/kern/init_main.c	2000/12/13 00:17:00	1.151
+++ sys/kern/init_main.c	2000/12/13 05:37:19
@@ -75,6 +75,7 @@
 #include <vm/vm_map.h>
 #include <sys/user.h>
 #include <sys/copyright.h>
+#include <sys/capability.h>
 
 extern struct linker_set	sysinit_set;	/* XXX */
 
@@ -322,6 +323,10 @@
 	p->p_cred = &cred0;
 	p->p_ucred = crget();
 	p->p_ucred->cr_ngroups = 1;	/* group 0 */
+
+	/* Give all kernel processes many capabilities */
+	cap_init_proc0(&p->p_ucred->cr_cap);
+
 	p->p_ucred->cr_uidinfo = uifind(0);
 
 	/* Don't jail it */
@@ -598,6 +603,12 @@
 		panic("cannot fork init: %d\n", error);
 	initproc->p_flag |= P_INMEM | P_SYSTEM;
 	cpu_set_fork_handler(initproc, start_init, NULL);
+
+	/*
+	 * Give init necessary capabilities to shut the system down and
+	 * avoid a panic when done.
+	 */
+	cap_init_proc1(&initproc->p_ucred->cr_cap);
 }
 SYSINIT(init,SI_SUB_CREATE_INIT, SI_ORDER_FIRST, create_init, NULL)
 
Index: sys/kern/kern_acct.c
===================================================================
RCS file: /home/ncvs/src/sys/kern/kern_acct.c,v
retrieving revision 1.27
diff -u -r1.27 kern_acct.c
--- sys/kern/kern_acct.c	2000/11/27 22:52:29	1.27
+++ sys/kern/kern_acct.c	2000/12/13 05:37:19
@@ -118,9 +118,9 @@
 	int error, flags;
 
 	/* Make sure that the caller is root. */
-	error = suser(p);
-	if (error)
+	if ((error = cap_check(NULL, p, CAP_SYS_PACCT, 0)) != 0)
 		return (error);
+	suser_used(p);
 
 	/*
 	 * If accounting is to be started to a file, open that file for
Index: sys/kern/kern_cap.c
===================================================================
RCS file: /home/ncvs/src/sys/kern/kern_cap.c,v
retrieving revision 1.5
diff -u -r1.5 kern_cap.c
--- sys/kern/kern_cap.c	2000/10/29 13:56:50	1.5
+++ sys/kern/kern_cap.c	2000/11/07 02:42:40
@@ -31,8 +31,6 @@
 /*
  * Developed by the TrustedBSD Project.
  * Support for POSIX.1e process capabilities.
- *
- * XXX: Currently just syscall stubs.
  */
 
 #include <sys/types.h>
@@ -50,14 +48,340 @@
 
 #include "opt_cap.h"
 
+static void	cap_zero(struct cap *cap_p);
+static int	cap_valid(struct cap *cap_p);
+static int	cap_subset(struct cap *cap1, struct cap *cap2);
+static int	cap_get_vp(struct vnode *vp, int ioflg, struct cap *cap_p,
+			struct proc *p);
+static int	cap_set_vp(struct vnode *vp, int ioflg, struct cap *cap_p,
+			struct proc *p);
+
+
+static int	kern_security_suser_enabled = 1;
+#ifdef CAPABILITIES
+static int	kern_security_capabilities_enabled = 1;
+#endif
+
+SYSCTL_NODE(_kern, OID_AUTO, security, CTLFLAG_RD, 0, "Kernel Security MIB");
+SYSCTL_INT(_kern_security, OID_AUTO, suser_permitted, CTLFLAG_RW,
+    &kern_security_suser_enabled, 0, "Super-user Enabled");
+#ifdef CAPABILITIES
+SYSCTL_INT(_kern_security, OID_AUTO, capabilities_enabled, CTLFLAG_RW,
+    &kern_security_capabilities_enabled, 0, "POSIX.1e Capabilities Enabled");
+#endif
+
+/*
+ * Return a capability set to a state where it has no flags enabled.
+ */
+static void
+cap_zero(struct cap *cap_p)
+{
+
+	bzero(cap_p, sizeof(*cap_p));
+}
+
+/*
+ * Check the validity of a capability set -- 0 on success, EINVAL otherwise
+ */
+static int
+cap_valid(struct cap *cap_p)
+{
+
+	/*
+	 * Effective cannot contain anything not in permitted.
+	 */
+	if ((cap_p->c_permitted | cap_p->c_effective) != cap_p->c_permitted)
+		return (EINVAL);
+	return (0);
+}
+
+/*
+ * Check whether cap2 is a strict subset of cap1, from the perspective
+ * of setting a new capability set for a process without appropriate
+ * privilege.
+ */
+static int
+cap_subset(struct cap *cap1, struct cap *cap2)
+{
+
+	/*
+	 * New permitted set must be a subset of the old permitted set.
+	 */
+	if ((cap2->c_permitted | cap1->c_permitted) !=
+	    cap1->c_permitted)
+		return (EPERM);
+
+	/*
+	 * New effective set must be a subset of the new permitted set.
+	 */
+	if ((cap2->c_effective | cap2->c_permitted) !=
+	    cap2->c_permitted)
+		return (EPERM);
+
+	/*
+	 * New inheritable set must be a subset of the old permitted set.
+	 */
+	if ((cap2->c_inheritable | cap1->c_permitted) !=
+	    cap1->c_permitted)
+		return (EPERM);
+	return (0);
+}
+
+/*
+ * cap_proc0: initialize capabilities for kernel processes
+ *
+ * XXX for now, give them all capabilities, as kernel processes may
+ * need to do all kinds of things.
+ */
+void
+cap_init_proc0(struct cap *cap_p)
+{
+
+	/* All available rights. */
+	cap_p->c_effective = ~0;
+	cap_p->c_permitted = ~0;
+	cap_p->c_inheritable = ~0;
+}
+
+/*
+ * cap_init: initialize capabilities for init
+ * 
+ * XXX init requires CAP_KILL in order to shut the system
+ * down successfully, as well as CAP_SYS_BOOT.
+ */
+void
+cap_init_proc1(struct cap *cap_p)
+{
+
+	bzero(cap_p, sizeof(struct cap));
+
+	/*
+	 * Give init(8) all rights, as it will need to pass them on
+	 * to startup processes during the system boot.  For safety,
+	 * default to non-inheritable for all of the capabilities,
+	 * allowing a legacy init(8) to operate safely on a
+	 * capabilities environment.
+	 *
+	 * XXX we may need to setsugid() init, so would require
+	 * a proc pointer, not just the cap pointer here.
+	 */
+	cap_p->c_effective = ~0;
+	cap_p->c_permitted = ~0;
+	cap_p->c_inheritable = 0;
+
+	/*
+	 * For reference, the following rights are the ones required for
+	 * normal system operation of init(8), leaving aside the
+	 * requirement that programs executed by init(8) might require
+	 * privilege.
+	 *
+	 * cap_p->c_effective = cap_p->c_permitted = cap_p->c_inheritable = 0;
+	 * SET_CAPABILITY(cap_p->c_permitted, CAP_KILL);
+	 * SET_CAPABILITY(cap_p->c_effective, CAP_KILL);
+	 * SET_CAPABILITY(cap_p->c_permitted, CAP_SYS_BOOT);
+	 * SET_CAPABILITY(cap_p->c_effective, CAP_SYS_BOOT);
+	 */
+}
+
 /*
+ * Perform capability inheritence on p, with optional vnode for a file
+ * from which to gain/mask new capabilities.  To not use a vnode, set
+ * vp to NULL.
+ *
+ * POSIX.1e defines the following inheritence:
+ *   pI` = pI
+ *   pP` = (fP & X) | (fI & pI)
+ *   pE` = (fE & pP`)
+ *
+ * We currently don't implement X, but will soon implement a per-process
+ * inherited bounding set to support jail().
+ * Linux currently uses: X = fB & (~pB) where fB is a per-fs bound, and
+ * pB is the inherited process bound.
+ *
+ * If capabilities have been disabled using the sysctl, new programs
+ * running are not permitted to acquire and capabilities regardless of
+ * their on-disk state, or inherited capabilities.
+ *
+ * If any capabilities are set on the process, i.e, requiring protection,
+ * then return (1), otherwise (0).  This allows the caller to determine
+ * what protection is appropriate.
+ */
+int
+cap_inherit(struct vnode *vp, struct proc *p)
+{
+	struct cap	cap_file;
+	struct cap	cap_new;
+	struct cap	*cap_p_proc;
+#ifdef CAPABILITIES
+	int	len;
+#endif
+	int	error;
+
+	/*
+	 * XXX have to do this, since we don't know if capabilities will
+	 * change.  This should be fixed to not crcopy if the capabilities
+	 * have not changed.
+	 */
+	p->p_ucred = crcopy(p->p_ucred);
+	cap_p_proc = &p->p_ucred->cr_cap;
+
+#ifdef CAPABILITIES
+	if (kern_security_capabilities_enabled == 1) {
+		len = sizeof(cap_file);
+		error =	cap_get_vp(vp, 0, &cap_file, p);
+		if (error) {
+			printf("cap_inherit: error retrieving capability\n");
+			printf("error: %d\n", error);
+		}
+	} else
+#endif
+		error = 1;	/* force zero'ing of capabilities */
+
+	if (error == 0) {
+		cap_new.c_inheritable = cap_p_proc->c_inheritable;
+		cap_new.c_permitted = cap_file.c_permitted |
+		    (cap_file.c_inheritable & cap_p_proc->c_inheritable);
+		cap_new.c_effective = cap_file.c_effective &
+		    cap_new.c_permitted;
+	} else {
+		cap_new.c_inheritable = 0;
+		cap_new.c_permitted = 0;
+		cap_new.c_effective = 0;
+	}
+	*cap_p_proc = cap_new;
+ 
+	/*
+	 * Currently, we protect a process only if some of its capability
+	 * bits end up being turned on.  Is this correct?
+	 */
+	if (cap_p_proc->c_permitted || cap_p_proc->c_effective)
+		return (1);
+	return (0);
+}
+
+/*
+ * cap_check: perform an authorization check to see if the given process
+ * appropriate privilege.  Flags model those of suser_xxx.
+ */
+int
+cap_check(const struct ucred *cred, const struct proc *proc,
+    cap_value_t cap, int flags)
+{
+
+	if (!cred && !proc) {
+		printf("cap_check(): THINK!\n");
+		return (EPERM);
+	}
+	if (!cred)
+		cred = proc->p_ucred;
+	/*
+	 * Disqualify processes in jail(), if flags indicate that jail()'d
+	 * processes cannot user privilege with this call.
+	 *
+	 * XXX: Right now, this only works if the process structure is
+	 * passed as an argument.
+	 * XXX: Eventually, jail(8) support will be implemented using
+	 * inherited capability bounds, meaning the flags can go away.
+	 */
+	if (proc && proc->p_prison && !(flags & PRISON_ROOT))
+		return (EPERM);
+#ifdef CAPABILITIES
+	/*
+	 * If capabilities are enabled, try to gain privilege through the
+	 * appropriate capability flag in the credential.
+	 */
+	if (kern_security_capabilities_enabled &&
+	    (cred->cr_cap.c_effective & cap))
+		return (0);
+#endif
+	/*
+	 * If the super-user is enabled, try to gain privilege through an
+	 * effective uid of 0.
+	 */
+	if (kern_security_suser_enabled &&
+	    (cred->cr_uid == 0))
+		return (0);
+	/*
+	 * Return failure, as no form of privilege was available to
+	 * authorize the request.
+	 */
+	return (EPERM);
+}
+
+/*
+ * Internal function to retrieve the capability block from a
+ * vnode.  Will always fill in the cap set, possibly by zero'ing it
+ * if the file doesn't have a capability, or if it is invalid.
+ */
+static int
+cap_get_vp(struct vnode *vp, int ioflg, struct cap *cap_p, struct proc *p)
+{
+	int	len, error;
+
+	/*
+	 * XXX: Check to see if this file system has capability support
+	 * enabled.
+	 */
+
+	len = sizeof(*cap_p);
+	error = vn_extattr_get(vp, ioflg, POSIX1E_CAPABILITY_EXTATTR_NAME,
+	    &len, (char *) cap_p, p);
+        /*
+         * XXX should check for ENOATTR and convert to null capability it
+         * received, not ENOENT
+         */
+	if (error == ENOENT || error == EOPNOTSUPP) {
+		/*
+		 * Coerce no capability attribute to a null capability set
+		 */
+		error = 0;
+		cap_zero(cap_p);
+	} else if (error == 0 && len != sizeof(*cap_p)) {
+		printf("__cap_get_file: invalid capability on file\n");
+		cap_zero(cap_p);
+	}
+	return (error);
+}
+
+/*
+ * Internal function to set the capability set for a vnode.
+ * Partial writes of extended attributes may be a problem if the
+ * underlying implementation doesn't properly return failure
+ * information.  A partial write *should* result in an invalid
+ * capability, which cap_get_vp will convert into a NULL capability
+ * set.  Let vn_extattr_set() handle locking.
+ */
+static int
+cap_set_vp(struct vnode *vp, int ioflg, struct cap *cap_p,
+    struct proc *p)
+{
+	int	len, error;
+
+	/*
+	 * XXX: Check to see if this file system has capability support
+	 * enabled.
+	 */
+
+	if ((error = cap_check(NULL, p, CAP_SETFCAP, PRISON_ROOT)))
+		return (error);
+
+	/* XXX Audit privilege here. */
+
+	len = sizeof(*cap_p);
+	error = vn_extattr_set(vp, ioflg, POSIX1E_CAPABILITY_EXTATTR_NAME,
+	    len, (char *) cap_p, p);
+	return (error);
+}
+
+/*
  * Syscall to allow a process to get it's currently capability set
  */
 int
 __cap_get_proc(struct proc *p, struct __cap_get_proc_args *uap)
 {
 
-	return (ENOSYS);
+	return (copyout(&p->p_ucred->cr_cap, (caddr_t)uap->cap_p,
+	    sizeof (struct cap)));
 }
 
 /*
@@ -67,10 +391,38 @@
 int
 __cap_set_proc(struct proc *p, struct __cap_set_proc_args *uap)
 {
+	struct cap	capability;
+	int	error, requires_privilege;
 
-	return (ENOSYS);
+	error = copyin(SCARG(uap, cap_p), &capability, sizeof(struct cap));
+	if (error)
+		return (error);
+
+	if ((error = cap_valid(&capability)))
+		return (error);
+
+	if (cap_subset(&p->p_ucred->cr_cap, &capability) == 0)
+		requires_privilege = 0;
+	else
+		requires_privilege = 1;
+
+	if (requires_privilege) {
+		if ((error = cap_check(NULL, p, CAP_SETPCAP, PRISON_ROOT)) !=
+		    0)
+			return (error);
+		suser_used(p);
+	}
+
+	/*
+	 * XXX: Ideally, this wouldn't be necessary.
+	 */
+	p->p_ucred = crcopy(p->p_ucred);
+	p->p_ucred->cr_cap = capability;
+
+	return (0);
 }
 
+
 /*
  * Syscalls to allow a process to retrieve capabilities associated with
  * files, if permitted.
@@ -78,15 +430,41 @@
 int
 __cap_get_fd(struct proc *p, struct __cap_get_fd_args *uap)
 {
+	struct filedesc	*fdp = p->p_fd;
+	struct file	*fp;
+	struct vnode	*vp;
+	struct cap	cap;
+	int	error;
+
+	if ((unsigned)uap->fd >= fdp->fd_nfiles ||
+	    (fp = fdp->fd_ofiles[uap->fd]) == NULL)
+		return (EBADF);
+	vp = (struct vnode *)fp->f_data;
+	error = cap_get_vp(vp, 0, &cap, p);
+	if (error == 0)
+		error = copyout(&cap, SCARG(uap, cap_p), sizeof(cap));
 
-	return (ENOSYS);
+	return (error);
 }
 
 int
 __cap_get_file(struct proc *p, struct __cap_get_file_args *uap)
 {
+	struct nameidata	nd;
+	struct cap	cap;
+	int	error;
+
+	NDINIT(&nd, LOOKUP, FOLLOW, UIO_USERSPACE,
+	    SCARG(uap, path_p), p);
+	if ((error = namei(&nd)) != 0)
+		return (error);
+
+	error = cap_get_vp(nd.ni_vp, 0, &cap, p);
+	if (error == 0)
+		error = copyout(&cap, SCARG(uap, cap_p), sizeof(cap));
 
-	return (ENOSYS);
+	NDFREE(&nd, 0);
+	return (error);
 }
 
 /*
@@ -96,13 +474,39 @@
 int
 __cap_set_fd(struct proc *p, struct __cap_set_fd_args *uap)
 {
-
-	return (ENOSYS);
+	struct filedesc	*fdp = p->p_fd;
+	struct file	*fp;
+	struct vnode	*vp;
+	struct cap	cap;
+	int	error;
+
+	error = copyin(SCARG(uap, cap_p), &cap, sizeof(cap));
+	if (error)
+		return (error);
+
+	if ((unsigned)uap->fd >= fdp->fd_nfiles ||
+	    (fp = fdp->fd_ofiles[uap->fd]) == NULL)
+		return (EBADF);
+	vp = (struct vnode *)fp->f_data;
+	error = cap_set_vp(vp, 0, &cap, p);
+	return (error);
 }
 
 int
 __cap_set_file(struct proc *p, struct __cap_set_file_args *uap)
 {
-
-	return (ENOSYS);
+	struct nameidata	nd;
+	struct cap	cap;
+	int	error;
+
+	error = copyin(SCARG(uap, cap_p), &cap, sizeof(cap));
+	if (error)
+		return (error);
+
+	NDINIT(&nd, LOOKUP, FOLLOW, UIO_USERSPACE, SCARG(uap, path_p), p);
+	if ((error = namei(&nd)) != 0)
+		return (error);
+	error = cap_set_vp(nd.ni_vp, 0, &cap, p);
+	NDFREE(&nd, 0);
+	return (error);
 }
Index: sys/kern/kern_exec.c
===================================================================
RCS file: /home/ncvs/src/sys/kern/kern_exec.c,v
retrieving revision 1.121
diff -u -r1.121 kern_exec.c
--- sys/kern/kern_exec.c	2000/12/23 19:43:09	1.121
+++ sys/kern/kern_exec.c	2001/01/05 17:01:03
@@ -48,6 +48,7 @@
 #include <sys/shm.h>
 #include <sys/sysctl.h>
 #include <sys/vnode.h>
+#include <sys/capability.h>
 
 #include <vm/vm.h>
 #include <vm/vm_param.h>
@@ -165,6 +166,7 @@
 
 	/*
 	 * Check file permissions (also 'opens' file)
+	 * XXX Capability interaction here?
 	 */
 	error = exec_check_permissions(imgp);
 	if (error) {
@@ -279,6 +281,8 @@
 	 *
 	 * Don't honor setuid/setgid if the filesystem prohibits it or if
 	 * the process is being traced.
+	 *
+	 * Do CAP execution stuff here, in style of setuid/setgid
 	 */
 	if ((((attr.va_mode & VSUID) && p->p_ucred->cr_uid != attr.va_uid) ||
 	     ((attr.va_mode & VSGID) && p->p_ucred->cr_gid != attr.va_gid)) &&
@@ -288,11 +292,13 @@
 		 * Turn off syscall tracing for set-id programs, except for
 		 * root.
 		 */
-		if (p->p_tracep && suser(p)) {
+		if (p->p_tracep && cap_check(NULL, p, CAP_SYS_PTRACE, 0)) {
 			p->p_traceflag = 0;
 			vrele(p->p_tracep);
 			p->p_tracep = NULL;
 		}
+		if (p->p_tracep)
+			suser_used(p);
 		/*
 		 * Set the new credentials.
 		 */
@@ -314,6 +320,30 @@
 	 */
 	p->p_cred->p_svuid = p->p_ucred->cr_uid;
 	p->p_cred->p_svgid = p->p_ucred->cr_gid;
+
+	/*
+	 * CAP inheritence, et al.
+	 * XXX should this be above the file CAP stuff?
+	 * XXX is this the right vp?  could be the vp from the interpreter.
+	 * XXX vp is now unlocked?
+	 * XXX What about ptrace() handling?
+	 * XXX is ordering here a problem?  (above does tracep first,
+	 * then rights, then sugid safety, but this is different)
+	 */
+	if (cap_inherit(ndp->ni_vp, p)) {
+		/*
+		 * Resulted in a process with capabilities.
+		 */
+		if (p->p_tracep && cap_check(NULL, p, CAP_SYS_PTRACE, 0)) {
+			p->p_traceflag = 0;
+			vrele(p->p_tracep);
+			p->p_tracep = NULL;
+		}
+		if (p->p_tracep)
+			suser_used(p);
+		setsugid(p);
+		setugidsafety(p);
+	}
 
 	/*
 	 * Store the vp for use in procfs
Index: sys/kern/kern_jail.c
===================================================================
RCS file: /home/ncvs/src/sys/kern/kern_jail.c,v
retrieving revision 1.9
diff -u -r1.9 kern_jail.c
--- sys/kern/kern_jail.c	2000/12/08 21:50:32	1.9
+++ sys/kern/kern_jail.c	2000/12/13 05:37:20
@@ -56,9 +56,10 @@
 	struct jail j;
 	struct chroot_args ca;
 
-	error = suser(p);
-	if (error)
+	if ((error = cap_check(NULL, p, CAP_SYS_CHROOT, 0)) != 0)
 		return (error);
+	suser_used(p);
+
 	error = copyin(uap->jail, &j, sizeof j);
 	if (error)
 		return (error);
Index: sys/kern/kern_linker.c
===================================================================
RCS file: /home/ncvs/src/sys/kern/kern_linker.c,v
retrieving revision 1.54
diff -u -r1.54 kern_linker.c
--- sys/kern/kern_linker.c	2000/12/28 08:14:58	1.54
+++ sys/kern/kern_linker.c	2001/01/05 17:01:03
@@ -693,8 +693,9 @@
     if (securelevel > 0)	/* redundant, but that's OK */
 	return EPERM;
 
-    if ((error = suser(p)) != 0)
+    if ((error = cap_check(NULL, p, CAP_SYS_MODULE, 0)) != 0)
 	return error;
+    suser_used(p);
 
     realpath = NULL;
     pathname = malloc(MAXPATHLEN, M_TEMP, M_WAITOK);
@@ -736,8 +737,9 @@
     if (securelevel > 0)	/* redundant, but that's OK */
 	return EPERM;
 
-    if ((error = suser(p)) != 0)
+    if ((error = cap_check(NULL, p, CAP_SYS_MODULE, 0)) != 0)
 	return error;
+    suser_used(p);
 
     lf = linker_find_file_by_id(SCARG(uap, fileid));
     if (lf) {
Index: sys/kern/kern_ntptime.c
===================================================================
RCS file: /home/ncvs/src/sys/kern/kern_ntptime.c,v
retrieving revision 1.37
diff -u -r1.37 kern_ntptime.c
--- sys/kern/kern_ntptime.c	2000/09/10 09:13:34	1.37
+++ sys/kern/kern_ntptime.c	2000/09/17 14:51:36
@@ -291,10 +291,11 @@
 	 * from the ntv.constant member, depending on the mode bits.
 	 */
 	modes = ntv.modes;
-	if (modes)
-		error = suser(p);
-	if (error)
-		return (error);
+	if (modes) {
+		if ((error = cap_check(NULL, p, CAP_SYS_TIME, 0)) != 0);
+			return (error);
+		suser_used(p);
+	}
 	s = splclock();
 	if (modes & MOD_FREQUENCY) {
 		freq = (ntv.freq * 1000LL) >> 16;
Index: sys/kern/kern_prot.c
===================================================================
RCS file: /home/ncvs/src/sys/kern/kern_prot.c,v
retrieving revision 1.70
diff -u -r1.70 kern_prot.c
--- sys/kern/kern_prot.c	2000/12/23 19:43:09	1.70
+++ sys/kern/kern_prot.c	2001/01/05 17:01:04
@@ -422,7 +422,7 @@
 #ifdef POSIX_APPENDIX_B_4_2_2	/* Use BSD-compat clause from B.4.2.2 */
 	    uid != pc->pc_ucred->cr_uid &&	/* allow setuid(geteuid()) */
 #endif
-	    (error = suser_xxx(0, p, PRISON_ROOT)))
+	    (error = cap_check(0, p, CAP_SETUID, PRISON_ROOT)) != 0)
 		return (error);
 
 #ifdef _POSIX_SAVED_IDS
@@ -434,7 +434,7 @@
 #ifdef POSIX_APPENDIX_B_4_2_2	/* Use the clause from B.4.2.2 */
 	    uid == pc->pc_ucred->cr_uid ||
 #endif
-	    suser_xxx(0, p, PRISON_ROOT) == 0) /* we are using privs */
+	    cap_check(0, p, CAP_SETUID, PRISON_ROOT) == 0)
 #endif
 	{
 		/*
@@ -486,7 +486,7 @@
 	euid = uap->euid;
 	if (euid != pc->p_ruid &&		/* allow seteuid(getuid()) */
 	    euid != pc->p_svuid &&		/* allow seteuid(saved uid) */
-	    (error = suser_xxx(0, p, PRISON_ROOT)))
+	    (error = cap_check(0, p, CAP_SETUID, PRISON_ROOT)))
 		return (error);
 	/*
 	 * Everything's okay, do it.  Copy credentials so other references do
@@ -533,7 +533,7 @@
 #ifdef POSIX_APPENDIX_B_4_2_2	/* Use BSD-compat clause from B.4.2.2 */
 	    gid != pc->pc_ucred->cr_groups[0] && /* allow setgid(getegid()) */
 #endif
-	    (error = suser_xxx(0, p, PRISON_ROOT)))
+	    (error = cap_check(0, p, CAP_SETGID, PRISON_ROOT)))
 		return (error);
 
 #ifdef _POSIX_SAVED_IDS
@@ -545,7 +545,7 @@
 #ifdef POSIX_APPENDIX_B_4_2_2	/* use the clause from B.4.2.2 */
 	    gid == pc->pc_ucred->cr_groups[0] ||
 #endif
-	    suser_xxx(0, p, PRISON_ROOT) == 0) /* we are using privs */
+	    cap_check(0, p, CAP_SETGID, PRISON_ROOT) == 0)
 #endif
 	{
 		/*
@@ -597,7 +597,7 @@
 	egid = uap->egid;
 	if (egid != pc->p_rgid &&		/* allow setegid(getgid()) */
 	    egid != pc->p_svgid &&		/* allow setegid(saved gid) */
-	    (error = suser_xxx(0, p, PRISON_ROOT)))
+	    (error = cap_check(0, p, CAP_SETGID, PRISON_ROOT)))
 		return (error);
 	if (pc->pc_ucred->cr_groups[0] != egid) {
 		pc->pc_ucred = crcopy(pc->pc_ucred);
@@ -623,7 +623,7 @@
 	register u_int ngrp;
 	int error;
 
-	if ((error = suser_xxx(0, p, PRISON_ROOT)))
+	if ((error = cap_check(0, p, CAP_SETGID, PRISON_ROOT)))
 		return (error);
 	ngrp = uap->gidsetsize;
 	if (ngrp > NGROUPS)
@@ -672,7 +672,7 @@
 	if (((ruid != (uid_t)-1 && ruid != pc->p_ruid && ruid != pc->p_svuid) ||
 	     (euid != (uid_t)-1 && euid != pc->pc_ucred->cr_uid &&
 	     euid != pc->p_ruid && euid != pc->p_svuid)) &&
-	    (error = suser_xxx(0, p, PRISON_ROOT)) != 0)
+	    (error = cap_check(0, p, CAP_SETUID, PRISON_ROOT)) != 0)
 		return (error);
 
 	if (euid != (uid_t)-1 && pc->pc_ucred->cr_uid != euid) {
@@ -712,7 +712,7 @@
 	if (((rgid != (gid_t)-1 && rgid != pc->p_rgid && rgid != pc->p_svgid) ||
 	     (egid != (gid_t)-1 && egid != pc->pc_ucred->cr_groups[0] &&
 	     egid != pc->p_rgid && egid != pc->p_svgid)) &&
-	    (error = suser_xxx(0, p, PRISON_ROOT)) != 0)
+	    (error = cap_check(0, p, CAP_SETGID, PRISON_ROOT)) != 0)
 		return (error);
 
 	if (egid != (gid_t)-1 && pc->pc_ucred->cr_groups[0] != egid) {
@@ -763,7 +763,7 @@
 	      euid != pc->pc_ucred->cr_uid) ||
 	     (suid != (uid_t)-1 && suid != pc->p_ruid && suid != pc->p_svuid &&
 	      suid != pc->pc_ucred->cr_uid)) &&
-	    (error = suser_xxx(0, p, PRISON_ROOT)) != 0)
+	    (error = cap_check(0, p, CAP_SETUID, PRISON_ROOT)) != 0)
 		return (error);
 	if (euid != (uid_t)-1 && pc->pc_ucred->cr_uid != euid) {
 		change_euid(p, euid);
@@ -811,7 +811,7 @@
 	      egid != pc->pc_ucred->cr_groups[0]) ||
 	     (sgid != (gid_t)-1 && sgid != pc->p_rgid && sgid != pc->p_svgid &&
 	      sgid != pc->pc_ucred->cr_groups[0])) &&
-	    (error = suser_xxx(0, p, PRISON_ROOT)) != 0)
+	    (error = cap_check(0, p, CAP_SETGID, PRISON_ROOT)) != 0)
 		return (error);
 
 	if (egid != (gid_t)-1 && pc->pc_ucred->cr_groups[0] != egid) {
@@ -928,6 +928,23 @@
 	return (0);
 }
 
+/*
+ * For accounting purposes, flag a process as having used super-user
+ * privileges.  Right now this is not called much, as most code still
+ * assumes that suser() will do the dirty work.  But this is incorrect
+ * behavior.  Use of suser_used() is difficult in current code due to
+ * abuse of short-circuit boolean evaluation to call or not call
+ * suser(), rather than isolating use of privilege.
+ */
+void
+suser_used(proc)
+	struct proc *proc;
+{
+
+	if (proc)
+		proc->p_acflag |= ASU;
+}
+
 static int suser_permitted = 1;
 
 SYSCTL_INT(_kern, OID_AUTO, suser_permitted, CTLFLAG_RW, &suser_permitted, 0,
@@ -935,8 +952,9 @@
 
 /*
  * Test whether the specified credentials imply "super-user"
- * privilege; if so, and we have accounting info, set the flag
- * indicating use of super-powers.
+ * privilege.  This used to also set the appropriate accounting flag,
+ * but now ``suser_used(p)'' must be called explicitely, as not all
+ * invocations of suser() result in the privilege being excercised.
  * Returns 0 or error.
  */
 int
@@ -978,14 +996,13 @@
 		return (ESRCH);
 
 	if (!ps_showallprocs && p1->p_ucred->cr_uid != p2->p_ucred->cr_uid) {
-		if (suser_xxx(NULL, p1, PRISON_ROOT) == 0) {
+		if (cap_check(NULL, p1, CAP_SYS_ADMIN, PRISON_ROOT) == 0) {
 			if (privused != NULL)
 				*privused = 1;
 			return (0);
 		}
 		return (ESRCH);
 	}
-
 	return (0);
 }
 
@@ -1014,21 +1031,12 @@
 		return (0);
 	if (p1->p_ucred->cr_uid == p2->p_ucred->cr_uid)
 		return (0);
-
-	if (!suser_xxx(0, p1, PRISON_ROOT)) {
+	if (!cap_check(NULL, p1, CAP_KILL, PRISON_ROOT)) {
 		if (privused != NULL)
 			*privused = 1;
 		return (0);
 	}
 
-#ifdef CAPABILITIES
-	if (!cap_check_xxx(0, p1, CAP_KILL, PRISON_ROOT)) {
-		if (privused != NULL)
-			*privused = 1;
-		return (0);
-	}
-#endif
-
 	return (EPERM);
 }
 
@@ -1057,21 +1065,12 @@
 		return (0);
 	if (p1->p_ucred->cr_uid == p2->p_ucred->cr_uid)
 		return (0);
-
-	if (!suser_xxx(0, p1, PRISON_ROOT)) {
+	if (!cap_check(0, p1, CAP_SYS_NICE, PRISON_ROOT)) {
 		if (privused != NULL)
 			*privused = 1;
 		return (0);
 	}
 
-#ifdef CAPABILITIES
-	if (!cap_check_xxx(0, p1, CAP_SYS_NICE, PRISON_ROOT)) {
-		if (privused != NULL)
-			*privused = 1;
-		return (0);
-	}
-#endif
-
 	return (EPERM);
 }
 
@@ -1096,7 +1095,8 @@
 	    p1->p_cred->p_ruid != p2->p_cred->p_ruid ||
 	    p1->p_cred->p_svuid != p2->p_cred->p_ruid ||
 	    p2->p_flag & P_SUGID) {
-		if ((error = suser_xxx(0, p1, PRISON_ROOT)))
+		if ((error =
+		   cap_check(NULL, p1, CAP_SYS_PTRACE, PRISON_ROOT)) != 0)
 			return (error);
 		if (privused != NULL)
 			*privused = 1;
@@ -1132,7 +1132,6 @@
 	}
 }
 
-
 /*
  * Allocate a zeroed cred structure.
  */
@@ -1262,7 +1261,7 @@
 	int error;
 	char logintmp[MAXLOGNAME];
 
-	if ((error = suser_xxx(0, p, PRISON_ROOT)))
+	if ((error = cap_check(0, p, CAP_SETUID, PRISON_ROOT)) != 0)
 		return (error);
 	error = copyinstr((caddr_t) uap->namebuf, (caddr_t) logintmp,
 	    sizeof(logintmp), (size_t *)0);
